All patches and comments are welcome. Please squash your changes to logical
commits before using git-format-patch and git-send-email to
patches@git.madduck.net.
If you'd read over the Git project's submission guidelines and adhered to them,
I'd be especially grateful.
5 mr - a tool to manage all your version control repos
9 B<mr> [options] checkout
11 B<mr> [options] update
13 B<mr> [options] status
15 B<mr> [options] commit [-m "message"]
17 B<mr> [options] record [-m "message"]
27 B<mr> [options] grep pattern
29 B<mr> [options] run command [param ...]
31 B<mr> [options] bootstrap src [directory]
33 B<mr> [options] register [repository]
35 B<mr> [options] config section ["parameter=[value]" ...]
37 B<mr> [options] action [params ...]
39 B<mr> [options] [online|offline]
41 B<mr> [options] remember action [params ...]
45 B<mr> is a tool to manage all your version control repos. It can checkout,
46 update, or perform other actions on a set of repositories as if they were
47 one combined repository. It supports any combination of subversion, git,
48 cvs, mercurial, bzr, darcs, fossil and veracity repositories, and support
49 for other version control systems can easily be added.
51 B<mr> cds into and operates on all registered repositories at or below your
52 working directory. Or, if you are in a subdirectory of a repository that
53 contains no other registered repositories, it will stay in that directory,
54 and work on only that repository,
56 B<mr> is configured by .mrconfig files, which list the repositories. It
57 starts by reading the .mrconfig file in your home directory, and this can
58 in turn chain load .mrconfig files from repositories. It also automatically
59 looks for a .mrconfig file in the current directory, or in one of its
62 These predefined commands should be fairly familiar to users of any version
67 =item checkout (or co)
69 Checks out any repositories that are not already checked out.
73 Updates each repository from its configured remote repository.
75 If a repository isn't checked out yet, it will first check it out.
79 Displays a status report for each repository, showing what
80 uncommitted changes are present in the repository. For distributed version
81 control systems, also shows unpushed local branches.
85 Commits changes to each repository. (By default, changes are pushed to the
86 remote repository too, when using distributed systems like git. If you
87 don't like this default, you can change it in your .mrconfig, or use record
90 The optional -m parameter allows specifying a commit message.
94 Records changes to the local repository, but does not push them to the
95 remote repository. Only supported for distributed version control systems.
97 The optional -m parameter allows specifying a commit message.
101 Fetches from each repository's remote repository, but does not
102 update the working copy. Only supported for some distributed version
107 Pushes committed local changes to the remote repository. A no-op for
108 centralized version control systems.
112 Show a diff of uncommitted changes.
120 Searches for a pattern in each repository using the grep subcommand. Uses
121 ack-grep on VCS that do not have their own.
123 =item run command [param ...]
125 Runs the specified command in each repository.
129 These commands are also available:
133 =item bootstrap src [directory]
135 Causes mr to retrieve the source C<src> and use it as a .mrconfig file to
136 checkout the repositories listed in it, into the specified directory.
138 B<mr> understands several types of sources:
144 C<src> may be an URL understood by B<curl>.
148 To use B<scp> to download, the C<src> may have the form
149 C<ssh://[user@]host:file>.
153 You can retrieve the config file by other means and pass its B<path> as C<src>.
157 If source C<src> consists in a single dash C<->, config file is read from
162 The directory will be created if it does not exist. If no directory is
163 specified, the current directory will be used.
165 As a special case, if source C<src> includes a repository named ".", that
166 is checked out into the top of the specified directory.
170 List the repositories that mr will act on.
174 Register an existing repository in a mrconfig file. By default, the
175 repository in the current directory is registered, or you can specify a
176 directory to register.
178 The mrconfig file that is modified is chosen by either the -c option, or by
179 looking for the closest known one at or in a parent of the current directory.
183 Adds, modifies, removes, or prints a value from a mrconfig file. The next
184 parameter is the name of the section the value is in. To add or modify
185 values, use one or more instances of "parameter=value". Use "parameter=" to
186 remove a parameter. Use just "parameter" to get the value of a parameter.
188 For example, to add (or edit) a repository in src/foo:
190 mr config src/foo checkout="svn co svn://example.com/foo/trunk foo"
192 To show the command that mr uses to update the repository in src/foo:
194 mr config src/foo update
196 To see the built-in library of shell functions contained in mr:
198 mr config DEFAULT lib
200 The mrconfig file that is used is chosen by either the -c option, or by
201 looking for the closest known one at or in a parent of the current directory.
205 Advises mr that it is in offline mode. Any commands that fail in
206 offline mode will be remembered, and retried when mr is told it's online.
210 Advices mr that it is in online mode again. Commands that failed while in
211 offline mode will be re-run.
215 Remember a command, to be run later when mr re-enters online mode. This
216 implicitly puts mr into offline mode. The command can be any regular mr
217 command. This is useful when you know that a command will fail due to being
218 offline, and so don't want to run it right now at all, but just remember
219 to run it when you go back online.
227 Actions can be abbreviated to any unambiguous substring, so
228 "mr st" is equivalent to "mr status", and "mr up" is equivalent to "mr
231 Additional parameters can be passed to most commands, and are passed on
232 unchanged to the underlying version control system. This is mostly useful
233 if the repositories mr will act on all use the same version control
242 =item --directory directory
244 Specifies the topmost directory that B<mr> should work in. The default is
245 the current working directory.
249 =item --config mrconfig
251 Use the specified mrconfig file. The default is to use both F<~/.mrconfig>
252 as well as look for a F<.mrconfig> file in the current directory, or in one
253 of its parent directories.
259 Force mr to act on repositories that would normally be skipped due to their
272 Be quiet. This suppresses mr's usual output, as well as any output from
273 commands that are run (including stderr output). If a command fails,
274 the output will be shown.
280 Accept untrusted SSL certificates when bootstrapping.
286 Expand the statistics line displayed at the end to include information
287 about exactly which repositories failed and were skipped, if any.
293 Interactive mode. If a repository fails to be processed, a subshell will be
294 started which you can use to resolve or investigate the problem. Exit the
295 subshell to continue the mr run.
299 =item --no-recurse [number]
301 If no number if specified, just operate on the repository for the current
302 directory, do not recurse into deeper repositories.
304 If a number is specified, will recurse into repositories at most that many
305 subdirectories deep. For example, with -n 2 it would recurse into ./src/foo,
306 but not ./src/packages/bar.
310 =item --jobs [number]
312 Run the specified number of jobs in parallel, or an unlimited number of jobs
313 with no number specified. This can greatly speed up operations such as updates.
314 It is not recommended for interactive operations.
316 Note that running more than 10 jobs at a time is likely to run afoul of
317 ssh connection limits. Running between 3 and 5 jobs at a time will yield
318 a good speedup in updates without loading the machine too much.
324 Trust all mrconfig files even if they are not listed in F<~/.mrtrust>.
331 This obsolete flag is ignored.
335 =head1 MRCONFIG FILES
337 Here is an example F<.mrconfig> file:
340 checkout = svn checkout svn://svn.example.com/src/trunk src
344 checkout = git clone git://git.kernel.org/pub/scm/linux/kernel/git/torvalds/linux-2.6.git &&
346 git checkout -b mybranch origin/master
348 The F<.mrconfig> file uses a variant of the INI file format. Lines
349 starting with "#" are comments. Values can be continued to the
350 following line by indenting the line with whitespace.
352 The C<DEFAULT> section allows setting default values for the sections that
355 The C<ALIAS> section allows adding aliases for actions. Each parameter
356 is an alias, and its value is the action to use.
358 All other sections add repositories. The section header specifies the
359 directory where the repository is located. This is relative to the directory
360 that contains the mrconfig file, but you can also choose to use absolute
361 paths. (Note that you can use environment variables in section names; they
362 will be passed through the shell for expansion. For example,
363 C<[$HOSTNAME]>, or C<[${HOSTNAME}foo]>).
365 Within a section, each parameter defines a shell command to run to handle a
366 given action. mr contains default handlers for "update", "status",
367 "commit", and other standard actions.
369 Normally you only need to specify what to do for "checkout". Here you
370 specify the command to run in order to create a checkout of the repository.
371 The command will be run in the parent directory, and must create the
372 repository's directory. So use C<git clone>, C<svn checkout>, C<bzr branch>
373 or C<bzr checkout> (for a bound branch), etc.
375 Note that these shell commands are run in a C<set -e> shell
376 environment, where any additional parameters you pass are available in
377 C<$@>. All commands other than "checkout" are run inside the repository,
378 though not necessarily at the top of it.
380 The C<MR_REPO> environment variable is set to the path to the top of the
381 repository. (For the "register" action, "MR_REPO" is instead set to the
382 basename of the directory that should be created when checking the
385 The C<MR_CONFIG> environment variable is set to the .mrconfig file
386 that defines the repo being acted on, or, if the repo is not yet in a config
387 file, the F<.mrconfig> file that should be modified to register the repo.
389 The C<MR_ACTION> environment variable is set to the command being run
390 (update, checkout, etc).
392 A few parameters have special meanings:
398 If the "skip" parameter is set and its command returns true, then B<mr>
399 will skip acting on that repository. The command is passed the action
402 Here are two examples. The first skips the repo unless
403 mr is run by joey. The second uses the hours_since function
404 (included in mr's built-in library) to skip updating the repo unless it's
405 been at least 12 hours since the last update.
409 skip = test `whoami` != joey
413 skip = [ "$1" = update ] && ! hours_since "$1" 12
415 Another way to use skip is for a lazy checkout. This makes mr skip
416 operating on a repo unless it already exists. To enable the
417 repo, you have to explicitly check it out (using "mr --force -d foo checkout").
425 The "order" parameter can be used to override the default ordering of
426 repositories. The default order value is 10. Use smaller values to make
427 repositories be processed earlier, and larger values to make repositories
430 Note that if a repository is located in a subdirectory of another
431 repository, ordering it to be processed earlier is not recommended.
435 If the "chain" parameter is set and its command returns true, then B<mr>
436 will try to load a F<.mrconfig> file from the root of the repository.
440 If the "include" parameter is set, its command is ran, and should output
441 additional mrconfig file content. The content is included as if it were
442 part of the including file.
444 Unlike all other parameters, this parameter does not need to be placed
447 B<mr> ships several libraries that can be included to add support for
448 additional version control type things (unison, git-svn, git-fake-bare,
449 git-subtree). To include them all, you could use:
451 include = cat /usr/share/mr/*
453 See the individual files for details.
457 If the "deleted" parameter is set and its command returns true, then
458 B<mr> will treat the repository as deleted. It won't ever actually delete
459 the repository, but it will warn if it sees the repository's directory.
460 This is useful when one mrconfig file is shared among multiple machines,
461 to keep track of and remember to delete old repositories.
465 The "lib" parameter can specify some shell code that will be run
466 before each command, this can be a useful way to define shell
467 functions for other commands to use.
469 Unlike most other parameters, this can be specified multiple times, in
470 which case the chunks of shell code are accumulatively concatenated
475 If the "fixups" parameter is set, its command is run whenever a repository
476 is checked out, or updated. This provides an easy way to do things
477 like permissions fixups, or other tweaks to the repository content,
478 whenever the repository is changed.
482 When looking for a command to run for a given action, mr first looks for
483 a parameter with the same name as the action. If that is not found, it
484 looks for a parameter named "VCS_action" (substituting in the name of the
485 version control system and the action).
487 Internally, mr has settings for "git_update", "svn_update", etc. To change
488 the action that is performed for a given version control system, you can
489 override these VCS specific actions. To add a new version control system,
490 you can just add VCS specific actions for it.
494 If a "pre_action" parameter is set, its command is run before mr performs the
495 specified action. Similarly, "post_action" parameters are run after mr
496 successfully performs the specified action. For example, "pre_commit" is
497 run before committing; "post_update" is run after updating.
501 Any parameter can be suffixed with C<_append>, to add an additional value
502 to the existing value of the parameter. In this way, actions
503 can be constructed accumulatively.
507 The name of the version control system is itself determined by
508 running each defined "VCS_test" action, until one succeeds.
512 =head1 UNTRUSTED MRCONFIG FILES
514 Since mrconfig files can contain arbitrary shell commands, they can do
515 anything. This flexibility is good, but it also allows a malicious mrconfig
516 file to delete your whole home directory. Such a file might be contained
517 inside a repository that your main F<~/.mrconfig> checks out. To
518 avoid worries about evil commands in a mrconfig file, mr defaults to
519 reading all mrconfig files other than the main F<~/.mrconfig> in untrusted
520 mode. In untrusted mode, mrconfig files are limited to running only known
521 safe commands (like "git clone") in a carefully checked manner.
523 To configure mr to trust other mrconfig files, list them in F<~/.mrtrust>.
524 One mrconfig file should be listed per line. Either the full pathname
525 should be listed, or the pathname can start with F<~/> to specify a file
526 relative to your home directory.
528 =head1 OFFLINE LOG FILE
530 The F<~/.mrlog> file contains commands that mr has remembered to run later,
531 due to being offline. You can delete or edit this file to remove commands,
532 or even to add other commands for 'mr online' to run. If the file is
533 present, mr assumes it is in offline mode.
537 mr can be extended to support things such as unison and git-svn. Some
538 files providing such extensions are available in F</usr/share/mr/>. See
539 the documentation in the files for details about using them.
543 mr returns nonzero if a command failed in any of the repositories.
547 Copyright 2007-2011 Joey Hess <joey@kitenet.net>
549 Licensed under the GNU GPL version 2 or higher.
551 http://myrepos.branchable.com/
558 use Cwd qw(getcwd abs_path);
560 # things that can happen when mr runs a command
569 my $config_overridden=0;
580 my $directory=getcwd();
582 my $HOME_MR_CONFIG = "$ENV{HOME}/.mrconfig";
583 $ENV{MR_CONFIG}=find_mrconfig();
590 my (@ok, @failed, @skipped);
600 # Runs a shell command using a supplied function.
601 # The lib will be included in the shell command line, and any params
602 # will be available in the shell as $1, $2, etc.
605 my ($action, $topdir, $subdir, $command, $params, $runner) = @_;
607 # optimisation: avoid running the shell for true and false
608 if ($command =~ /^\s*true\s*$/) {
612 elsif ($command =~ /^\s*false\s*$/) {
617 my $quotedparams=join(" ", (map { shellquote($_) } @$params));
618 my $lib=exists $config{$topdir}{$subdir}{lib} ?
619 $config{$topdir}{$subdir}{lib}."\n" : "";
620 if ($verbose && (! defined $lastlib || $lastlib ne $lib)) {
621 print "mr library now: >>$lib<<\n";
624 my $shellcode="set -e;".$lib.
625 "my_sh(){ $command\n }; my_sh $quotedparams";
626 print "mr $action: running $action >>$command<<\n" if $verbose;
627 $runner->($shellcode);
634 if ($s =~ m/^perl:\s+(.*)/s) {
635 return $perl_cache{$1} if exists $perl_cache{$1};
636 my $sub=eval "sub {$1}";
637 if (! defined $sub) {
638 print STDERR "mr: bad perl code in $id: $@\n";
640 return $perl_cache{$1} = $sub;
647 my ($action, $dir, $topdir, $subdir) = @_;
649 if (exists $vcs{$dir}) {
655 foreach my $vcs_test (
657 length $a <=> length $b
660 } grep { /_test$/ } keys %{$config{$topdir}{$subdir}}) {
661 my ($vcs)=$vcs_test =~ /(.*)_test/;
662 my $p=perl($vcs_test, $config{$topdir}{$subdir}{$vcs_test});
667 $test="my_$vcs_test() {\n$config{$topdir}{$subdir}{$vcs_test}\n}\n".$test;
668 $test.="if my_$vcs_test; then echo $vcs; fi\n";
673 foreach my $vcs (keys %perltest) {
674 if ($perltest{$vcs}->()) {
679 push @vcs, split(/\n/,
680 runsh("vcs test", $topdir, $subdir, $test, [], sub {
686 print STDERR "mr $action: found multiple possible repository types (@vcs) for ".fulldir($topdir, $subdir)."\n";
690 return $vcs{$dir}=undef;
693 return $vcs{$dir}=$vcs[0];
698 my ($action, $dir, $topdir, $subdir, $is_checkout) = @_;
700 if (exists $config{$topdir}{$subdir}{$action}) {
701 return $config{$topdir}{$subdir}{$action};
708 my $vcs=vcs_test(@_);
711 exists $config{$topdir}{$subdir}{$vcs."_".$action}) {
712 return $config{$topdir}{$subdir}{$vcs."_".$action};
720 my ($topdir, $subdir) = @_;
721 return $subdir =~ /^\// ? $subdir : $topdir.$subdir;
725 my ($action, $dir, $topdir, $subdir, $force_checkout) = @_;
726 my $fulldir=fulldir($topdir, $subdir);
729 $ENV{MR_CONFIG}=$configfiles{$topdir};
730 my $is_checkout=($action eq 'checkout');
731 my $is_update=($action =~ /update/);
733 ($ENV{MR_REPO}=$dir) =~ s!/$!!;
734 $ENV{MR_ACTION}=$action;
736 foreach my $testname ("skip", "deleted") {
737 next if $force && $testname eq "skip";
739 my $testcommand=findcommand($testname, $dir, $topdir, $subdir, $is_checkout);
741 if (defined $testcommand) {
742 my $ret=runsh "$testname test", $topdir, $subdir,
743 $testcommand, [$action],
744 sub { system(shift()) };
746 if (($? & 127) == 2) {
747 print STDERR "mr $action: interrupted\n";
751 print STDERR "mr $action: $testname test received signal ".($? & 127)."\n";
755 if ($ret >> 8 == 0) {
756 if ($testname eq "deleted") {
758 print STDERR "mr error: $dir should be deleted yet still exists\n";
762 print "mr $action: skip $dir skipped\n" if $verbose;
770 if (! $force_checkout) {
772 print "mr $action: $dir already exists, skipping checkout\n" if $verbose;
776 $dir=~s/^(.*)\/[^\/]+\/?$/$1/;
781 return action("checkout", $dir, $topdir, $subdir);
785 my $command=findcommand($action, $dir, $topdir, $subdir, $is_checkout);
787 if ($is_checkout && ! -d $dir) {
788 print "mr $action: creating parent directory $dir\n" if $verbose;
789 system("mkdir", "-p", $dir);
792 if (! $no_chdir && ! chdir($dir)) {
793 print STDERR "mr $action: failed to chdir to $dir: $!\n";
796 elsif (! defined $command) {
797 my $vcs=vcs_test(@_);
798 if (! defined $vcs) {
799 print STDERR "mr $action: unknown repository type and no defined $action command for $fulldir\n";
803 print STDERR "mr $action: no defined action for $vcs repository $fulldir, skipping\n";
810 $actionmsg="mr $action: $fulldir";
814 $s=~s/^\Q$fulldir\E\/?//;
815 $actionmsg="mr $action: $fulldir (in subdir $s)";
817 print "$actionmsg\n" unless $quiet;
819 my $hookret=hook("pre_$action", $topdir, $subdir);
820 return $hookret if $hookret != OK;
822 my $ret=runsh $action, $topdir, $subdir,
823 $command, \@ARGV, sub {
826 my $output = qx/$sh 2>&1/;
829 print "$actionmsg\n";
830 print STDERR $output;
839 if (($? & 127) == 2) {
840 print STDERR "mr $action: interrupted\n";
844 print STDERR "mr $action: received signal ".($? & 127)."\n";
847 print STDERR "mr $action: failed ($ret)\n" if $verbose;
848 if ($ret >> 8 != 0) {
849 print STDERR "mr $action: command failed\n";
850 if (-e "$ENV{HOME}/.mrlog" && $action ne 'remember') {
851 # recreate original command line to
852 # remember, and avoid recursing
854 @ARGV=('-n', $action, @orig);
855 action("remember", $dir, $topdir, $subdir);
860 print STDERR "mr $action: command died ($ret)\n";
865 if ($is_checkout && ! -d $dir) {
866 print STDERR "mr $action: $dir missing after checkout\n";;
870 my $ret=hook("post_$action", $topdir, $subdir);
871 return $ret if $ret != OK;
873 if ($is_checkout || $is_update) {
874 if ($is_checkout && ! $no_chdir) {
875 if (! chdir($checkout_dir)) {
876 print STDERR "mr $action: failed to chdir to $checkout_dir: $!\n";
880 my $ret=hook("fixups", $topdir, $subdir);
881 return $ret if $ret != OK;
890 my ($hook, $topdir, $subdir) = @_;
892 my $command=$config{$topdir}{$subdir}{$hook};
893 return OK unless defined $command;
894 my $ret=runsh $hook, $topdir, $subdir, $command, [], sub {
897 my $output = qx/$sh 2>&1/;
900 print STDERR $output;
909 if (($? & 127) == 2) {
910 print STDERR "mr $hook: interrupted\n";
914 print STDERR "mr $hook: received signal ".($? & 127)."\n";
925 # run actions on multiple repos, in parallel
935 while (@fhs or @repos) {
936 while ((!$jobs || $running < $jobs) && @repos) {
938 my $repo = shift @repos;
939 pipe(my $outfh, CHILD_STDOUT);
940 pipe(my $errfh, CHILD_STDERR);
942 unless ($pid = fork) {
943 die "mr $action: cannot fork: $!" unless defined $pid;
944 open(STDOUT, ">&CHILD_STDOUT") || die "mr $action cannot reopen stdout: $!";
945 open(STDERR, ">&CHILD_STDERR") || die "mr $action cannot reopen stderr: $!";
950 exit action($action, @$repo);
954 push @active, [$pid, $repo];
955 push @fhs, [$outfh, $errfh];
958 my ($rin, $rout) = ('','');
960 foreach my $fh (@fhs) {
961 next unless defined $fh;
962 vec($rin, fileno($fh->[0]), 1) = 1 if defined $fh->[0];
963 vec($rin, fileno($fh->[1]), 1) = 1 if defined $fh->[1];
965 $nfound = select($rout=$rin, undef, undef, 1);
966 foreach my $channel (0, 1) {
967 foreach my $i (0..$#fhs) {
968 next unless defined $fhs[$i];
969 my $fh = $fhs[$i][$channel];
970 next unless defined $fh;
971 if (vec($rout, fileno($fh), 1) == 1) {
973 if (sysread($fh, $r, 1024) == 0) {
975 $fhs[$i][$channel] = undef;
976 if (! defined $fhs[$i][0] &&
977 ! defined $fhs[$i][1]) {
978 waitpid($active[$i][0], 0);
979 print STDOUT $out[$i][0];
980 print STDERR $out[$i][1];
981 record($active[$i][1], $? >> 8);
983 splice(@active, $i, 1);
988 $out[$i][$channel] .= $r;
996 my $dir=shift()->[0];
1001 print "\n" unless $quiet;
1003 elsif ($ret == FAILED) {
1005 chdir($dir) unless $no_chdir;
1006 print STDERR "mr: Starting interactive shell. Exit shell to continue.\n";
1007 system((getpwuid($<))[8], "-i");
1010 print "\n" unless $quiet;
1012 elsif ($ret == SKIPPED) {
1013 push @skipped, $dir;
1015 elsif ($ret == ABORT) {
1019 die "unknown exit status $ret";
1025 if (! @ok && ! @failed && ! @skipped) {
1026 die "mr $action: no repositories found to work on\n";
1028 print "mr $action: finished (".join("; ",
1029 showstat($#ok+1, "ok", "ok"),
1030 showstat($#failed+1, "failed", "failed"),
1031 showstat($#skipped+1, "skipped", "skipped"),
1032 ).")\n" unless $quiet;
1035 print "mr $action: (skipped: ".join(" ", @skipped).")\n" unless $quiet;
1038 print STDERR "mr $action: (failed: ".join(" ", @failed).")\n";
1048 return "$count ".($count > 1 ? $plural : $singular);
1053 # an ordered list of repos
1056 foreach my $topdir (sort keys %config) {
1057 foreach my $subdir (sort keys %{$config{$topdir}}) {
1061 order => $config{$topdir}{$subdir}{order},
1066 $a->{order} <=> $b->{order}
1068 $a->{topdir} cmp $b->{topdir}
1070 $a->{subdir} cmp $b->{subdir}
1076 my $topdir=$repo->{topdir};
1077 my $subdir=$repo->{subdir};
1078 my $ret=($subdir =~/^\//) ? $subdir : $topdir.$subdir;
1083 # Figure out which repos to act on. Returns a list of array refs
1086 # [ "$full_repo_path/", "$mr_config_path/", $section_header ]
1089 foreach my $repo (repolist()) {
1090 my $topdir=$repo->{topdir};
1091 my $subdir=$repo->{subdir};
1093 next if $subdir eq 'DEFAULT';
1094 my $dir=repodir($repo);
1096 $dir.="/" unless $dir=~/\/$/;
1097 $d.="/" unless $d=~/\/$/;
1098 next if $dir ne $d && $dir !~ /^\Q$d\E/;
1099 if (defined $max_depth) {
1100 my @a=split('/', $dir);
1101 my @b=split('/', $d);
1102 do { } while (@a && @b && shift(@a) eq shift(@b));
1103 next if @a > $max_depth || @b > $max_depth;
1105 push @repos, [$dir, $topdir, $subdir];
1108 # fallback to find a leaf repo
1109 foreach my $repo (reverse repolist()) {
1110 my $topdir=$repo->{topdir};
1111 my $subdir=$repo->{subdir};
1113 next if $subdir eq 'DEFAULT';
1114 my $dir=repodir($repo);
1116 $dir.="/" unless $dir=~/\/$/;
1117 $d.="/" unless $d=~/\/$/;
1118 if ($d=~/^\Q$dir\E/) {
1119 push @repos, [$dir, $topdir, $subdir];
1141 sub is_trusted_config {
1142 my $config=shift; # must be abs_pathed already
1144 # We always trust ~/.mrconfig.
1145 return 1 if $config eq abs_path($HOME_MR_CONFIG);
1147 return 1 if $trust_all;
1149 my $trustfile=$ENV{HOME}."/.mrtrust";
1152 $trusted{$HOME_MR_CONFIG}=1;
1153 if (open (TRUST, "<", $trustfile)) {
1156 s/^~\//$ENV{HOME}\//;
1157 $trusted{abs_path($_)}=1;
1163 return $trusted{$config};
1167 sub is_trusted_repo {
1170 # Tightly limit what is allowed in a repo name.
1171 # No ../, no absolute paths, and no unusual filenames
1172 # that might try to escape to the shell.
1173 return $repo =~ /^[-_.+\/A-Za-z0-9]+$/ &&
1174 $repo !~ /\.\./ && $repo !~ /^\//;
1177 sub is_trusted_checkout {
1180 # To determine if the command is safe, compare it with the
1181 # *_trusted_checkout config settings. Those settings are
1182 # templates for allowed commands, so make sure that each word
1183 # of the command matches the corresponding word of the template.
1186 foreach my $word (split(' ', $command)) {
1188 if ($word=~/^'(.*)'$/) {
1191 elsif ($word=~/^"(.*)"$/) {
1198 foreach my $key (grep { /_trusted_checkout$/ }
1199 keys %{$config{''}{DEFAULT}}) {
1200 my @twords=split(' ', $config{''}{DEFAULT}{$key});
1201 next if @words > @twords;
1205 for (my $c=0; $c < @twords && $match; $c++) {
1206 if ($twords[$c] eq '$url') {
1207 # Match all the typical characters found in
1208 # urls, plus @ which svn can use. Note
1209 # that the "url" might also be a local
1212 defined $words[$c] &&
1213 $words[$c] =~ /^[-_.+:@\/A-Za-z0-9]+$/
1217 elsif ($twords[$c] eq '$repo') {
1218 # If a repo is not specified, assume it
1219 # will be the last path component of the
1220 # url, or something derived from it, and
1222 if (! defined $words[$c] && defined $url) {
1223 ($words[$c])=$url=~/\/([^\/]+)\/?$/;
1227 defined $words[$c] &&
1228 is_trusted_repo($words[$c])
1231 elsif (defined $words[$c] && $words[$c]=~/^($twords[$c])$/) {
1248 my $bootstrap_src=shift;
1254 if (ref $f eq 'GLOB') {
1260 my $absf=abs_path($f);
1261 if ($loaded{$absf}) {
1266 $trusted=is_trusted_config($absf);
1268 if (! defined $dir) {
1269 ($dir)=$f=~/^(.*\/)[^\/]+$/;
1270 if (! defined $dir) {
1275 $dir=abs_path($dir)."/";
1277 if (! exists $configfiles{$dir}) {
1278 $configfiles{$dir}=$f;
1281 # copy in defaults from first parent
1283 while ($parent=~s/^(.*\/)[^\/]+\/?$/$1/) {
1284 if ($parent eq '/') {
1287 if (exists $config{$parent} &&
1288 exists $config{$parent}{DEFAULT}) {
1289 $config{$dir}{DEFAULT}={ %{$config{$parent}{DEFAULT}} };
1298 print "mr: loading config $f\n" if $verbose;
1299 open($in, "<", $f) || die "mr: open $f: $!\n";
1302 close $in unless ref $f eq 'GLOB';
1306 # Keep track of the current line in the config file;
1307 # when a file is included track the current line from the include.
1312 my $nextline = sub {
1324 my $lineerror = sub {
1326 if (defined $included) {
1327 die "mr: $msg at $f line $lineno, included line: $line\n";
1330 die "mr: $msg at $f line $lineno\n";
1333 my $trusterror = sub {
1336 if (defined $bootstrap_src) {
1337 die "mr: $msg in untrusted $bootstrap_src line $lineno\n".
1338 "(To trust this url, --trust-all can be used; but please use caution;\n".
1339 "this can allow arbitrary code execution!)\n";
1342 die "mr: $msg in untrusted $f line $lineno\n".
1343 "(To trust this file, list it in ~/.mrtrust.)\n";
1350 next if /^\s*\#/ || /^\s*$/;
1352 if (! $trusted && /[[:cntrl:]]/) {
1353 $trusterror->("illegal control character");
1356 if (/^\[([^\]]*)\]\s*$/) {
1360 if (! is_trusted_repo($section) ||
1361 $section eq 'ALIAS' ||
1362 $section eq 'DEFAULT') {
1363 $trusterror->("illegal section \"[$section]\"");
1366 $section=expandenv($section) if $trusted;
1367 if ($section ne 'ALIAS' &&
1368 ! exists $config{$dir}{$section} &&
1369 exists $config{$dir}{DEFAULT}) {
1371 $config{$dir}{$section}={ %{$config{$dir}{DEFAULT}} };
1374 elsif (/^(\w+)\s*=\s*(.*)/) {
1379 while (@lines && $lines[0]=~/^\s(.+)/) {
1386 # Untrusted files can only contain a few
1387 # settings in specific known-safe formats.
1388 if ($parameter eq 'checkout') {
1389 if (! is_trusted_checkout($value)) {
1390 $trusterror->("illegal checkout command \"$value\"");
1393 elsif ($parameter eq 'order') {
1394 # not interpreted as a command, so
1397 elsif ($value eq 'true' || $value eq 'false') {
1398 # skip=true , deleted=true etc are
1402 $trusterror->("illegal setting \"$parameter=$value\"");
1406 if ($parameter eq "include") {
1407 print "mr: including output of \"$value\"\n" if $verbose;
1410 print STDERR "mr: include command exited nonzero ($?)\n";
1413 unshift @lines, @inc;
1417 if (! defined $section) {
1418 $lineerror->("parameter ($parameter) not in section");
1420 if ($section eq 'ALIAS') {
1421 $alias{$parameter}=$value;
1423 elsif ($parameter eq 'lib' or $parameter =~ s/_append$//) {
1424 $config{$dir}{$section}{$parameter}.="\n".$value."\n";
1427 $config{$dir}{$section}{$parameter}=$value;
1428 if ($parameter =~ /.*_(.*)/) {
1429 $knownactions{$1}=1;
1432 $knownactions{$parameter}=1;
1434 if ($parameter eq 'chain' &&
1435 length $dir && $section ne "DEFAULT") {
1436 my $chaindir="$section";
1437 if ($chaindir !~ m!^/!) {
1438 $chaindir=$dir.$chaindir;
1440 if (-e "$chaindir/.mrconfig") {
1441 my $ret=system($value);
1443 if (($? & 127) == 2) {
1444 print STDERR "mr: chain test interrupted\n";
1448 print STDERR "mr: chain test received signal ".($? & 127)."\n";
1452 push @toload, ["$chaindir/.mrconfig", $chaindir];
1459 $lineerror->("parse error");
1463 foreach my $c (@toload) {
1468 sub startingconfig {
1469 %alias=%config=%configfiles=%knownactions=%loaded=();
1470 my $datapos=tell(DATA);
1472 seek(DATA,$datapos,0); # rewind
1477 # the section to modify or add
1478 my $targetsection=shift;
1479 # fields to change in the section
1480 # To remove a field, set its value to "".
1481 my %changefields=@_;
1487 open(my $in, "<", $f) || die "mr: open $f: $!\n";
1492 my $formatfield=sub {
1494 my @value=split(/\n/, shift);
1496 return "$field = ".shift(@value)."\n".
1497 join("", map { "\t$_\n" } @value);
1501 while ($out[$#out] =~ /^\s*$/) {
1502 unshift @blanks, pop @out;
1504 foreach my $field (sort keys %changefields) {
1505 if (length $changefields{$field}) {
1506 push @out, "$field = $changefields{$field}\n";
1507 delete $changefields{$field};
1517 if (/^\s*\#/ || /^\s*$/) {
1520 elsif (/^\[([^\]]*)\]\s*$/) {
1521 if (defined $section &&
1522 $section eq $targetsection) {
1526 $section=expandenv($1);
1530 elsif (/^(\w+)\s*=\s(.*)/) {
1535 while (@lines && $lines[0]=~/^\s(.+)/) {
1541 if ($section eq $targetsection) {
1542 if (exists $changefields{$parameter}) {
1543 if (length $changefields{$parameter}) {
1544 $value=$changefields{$parameter};
1546 delete $changefields{$parameter};
1550 push @out, $formatfield->($parameter, $value);
1554 if (defined $section &&
1555 $section eq $targetsection) {
1558 elsif (%changefields) {
1559 push @out, "\n[$targetsection]\n";
1560 foreach my $field (sort keys %changefields) {
1561 if (length $changefields{$field}) {
1562 push @out, $formatfield->($field, $changefields{$field});
1567 open(my $out, ">", $f) || die "mr: write $f: $!\n";
1575 # actions that do not operate on all repos
1576 if ($action eq 'config') {
1579 elsif ($action eq 'register') {
1582 elsif ($action eq 'bootstrap') {
1585 elsif ($action eq 'remember' ||
1586 $action eq 'offline' ||
1587 $action eq 'online') {
1588 my @repos=selectrepos;
1589 action($action, @{$repos[0]}) if @repos;
1593 if (!$jobs || $jobs > 1) {
1594 mrs($action, selectrepos());
1597 foreach my $repo (selectrepos()) {
1598 record($repo, action($action, @$repo));
1607 SHOWMANFILE="man -f"
1616 if [ ! -e "$MR_PATH" ]; then
1617 error "cannot find program path"
1619 tmp=$(mktemp -t mr.XXXXXXXXXX) || error "mktemp failed"
1620 trap "rm -f $tmp" exit
1621 pod2man -c mr "$MR_PATH" > "$tmp" || error "pod2man failed"
1622 $SHOWMANFILE "$tmp" || error "man failed"
1624 exec($help) || die "exec: $!";
1629 die "mr config: not enough parameters\n";
1632 if ($section=~/^\//) {
1633 # try to convert to a path relative to the config file
1634 my ($dir)=$ENV{MR_CONFIG}=~/^(.*\/)[^\/]+$/;
1635 $dir=abs_path($dir);
1636 $dir.="/" unless $dir=~/\/$/;
1637 if ($section=~/^\Q$dir\E(.*)/) {
1643 if (/^([^=]+)=(.*)$/) {
1644 $changefields{$1}=$2;
1648 foreach my $topdir (sort keys %config) {
1649 if (exists $config{$topdir}{$section} &&
1650 exists $config{$topdir}{$section}{$_}) {
1651 print $config{$topdir}{$section}{$_}."\n";
1653 last if $section eq 'DEFAULT';
1657 die "mr config: $section $_ not set\n";
1661 modifyconfig($ENV{MR_CONFIG}, $section, %changefields) if %changefields;
1666 if ($config_overridden) {
1667 # Find the directory that the specified config file is
1669 ($directory)=abs_path($ENV{MR_CONFIG})=~/^(.*\/)[^\/]+$/;
1672 # Find the closest known mrconfig file to the current
1674 $directory.="/" unless $directory=~/\/$/;
1676 foreach my $topdir (reverse sort keys %config) {
1677 next unless length $topdir;
1678 if ($directory=~/^\Q$topdir\E/) {
1679 $ENV{MR_CONFIG}=$configfiles{$topdir};
1685 if (! $foundconfig) {
1686 $directory=""; # no config file, use builtin
1690 my $subdir=shift @ARGV;
1691 if (! chdir($subdir)) {
1692 print STDERR "mr register: failed to chdir to $subdir: $!\n";
1696 $ENV{MR_REPO}=getcwd();
1697 my $command=findcommand("register", $ENV{MR_REPO}, $directory, 'DEFAULT', 0);
1698 if (! defined $command) {
1699 die "mr register: unknown repository type\n";
1702 $ENV{MR_REPO}=~s/.*\/(.*)/$1/;
1703 $command="set -e; ".$config{$directory}{DEFAULT}{lib}."\n".
1704 "my_action(){ $command\n }; my_action ".
1705 join(" ", map { s/\\/\\\\/g; s/"/\"/g; '"'.$_.'"' } @ARGV);
1706 print "mr register: running >>$command<<\n" if $verbose;
1707 exec($command) || die "exec: $!";
1711 eval q{use File::Copy};
1714 my $src=shift @ARGV;
1715 my $dir=shift @ARGV || ".";
1717 if (! defined $src || ! length $src) {
1718 die "mr: bootstrap requires source\n";
1721 # Retrieve config file.
1722 eval q{use File::Temp};
1724 my $tmpconfig=File::Temp->new();
1725 if ($src =~ m!^[\w\d]+://!) {
1726 # Download the config file to a temporary location.
1728 if ($src =~ m!^ssh://(.*)!) {
1729 @downloader = ("scp", $1, $tmpconfig);
1732 @downloader = ("curl", "-A", "mr", "-L", "-s", $src, "-o", $tmpconfig);
1733 push(@downloader, "-k") if $insecure;
1735 my $status = system(@downloader);
1736 die "mr bootstrap: invalid SSL certificate for $src (consider -k)\n"
1737 if $downloader[0] eq 'curl' && $status >> 8 == 60;
1738 die "mr bootstrap: download of $src failed\n" if $status != 0;
1740 elsif ($src eq '-') {
1741 # Config file is read from stdin.
1742 copy(\*STDIN, $tmpconfig) || die "stdin: $!";
1745 # Config file is local.
1746 die "mr bootstrap: cannot read file '$src'"
1748 copy($src, $tmpconfig) || die "copy: $!";
1751 # Sanity check on destination directory.
1753 system("mkdir", "-p", $dir);
1755 chdir($dir) || die "chdir $dir: $!";
1757 # Special case to handle checkout of the "." repo, which
1758 # would normally be skipped.
1759 my $topdir=abs_path(".")."/";
1760 my @repo=($topdir, $topdir, ".");
1761 loadconfig($tmpconfig, $topdir, $src);
1762 record(\@repo, action("checkout", @repo, 1))
1763 if exists $config{$topdir}{"."}{"checkout"};
1765 if (-e ".mrconfig") {
1766 print STDERR "mr bootstrap: .mrconfig file already exists, not overwriting with $src\n";
1769 move($tmpconfig, ".mrconfig") || die "rename: $!";
1772 # Reload the config file (in case we got a different version)
1773 # and checkout everything else.
1775 loadconfig(".mrconfig");
1776 dispatch("checkout");
1777 @skipped=grep { abs_path($_) ne abs_path($topdir) } @skipped;
1778 showstats("bootstrap");
1782 # alias expansion and command stemming
1785 if (exists $alias{$action}) {
1786 $action=$alias{$action};
1788 if (! exists $knownactions{$action}) {
1789 my @matches = grep { /^\Q$action\E/ }
1790 keys %knownactions, keys %alias;
1791 if (@matches == 1) {
1792 $action=$matches[0];
1794 elsif (@matches == 0) {
1795 die "mr: unknown action \"$action\" (known actions: ".
1796 join(", ", sort keys %knownactions).")\n";
1799 die "mr: ambiguous action \"$action\" (matches: ".
1800 join(", ", @matches).")\n";
1808 while (length $dir) {
1809 if (-e "$dir/.mrconfig") {
1810 return "$dir/.mrconfig";
1812 $dir=~s/\/[^\/]*$//;
1814 return $HOME_MR_CONFIG;
1819 Getopt::Long::Configure("bundling", "no_permute");
1820 my $result=GetOptions(
1821 "d|directory=s" => sub { $directory=abs_path($_[1]) },
1822 "c|config=s" => sub { $ENV{MR_CONFIG}=$_[1]; $config_overridden=1 },
1823 "p|path" => sub { }, # now default, ignore
1824 "f|force" => \$force,
1825 "v|verbose" => \$verbose,
1826 "q|quiet" => \$quiet,
1827 "s|stats" => \$stats,
1828 "k|insecure" => \$insecure,
1829 "i|interactive" => \$interactive,
1830 "n|no-recurse:i" => \$max_depth,
1831 "j|jobs:i" => \$jobs,
1832 "t|trust-all" => \$trust_all,
1834 if (! $result || @ARGV < 1) {
1835 die("Usage: mr [options] action [params ...]\n".
1836 "(Use mr help for man page.)\n");
1839 $ENV{MR_SWITCHES}="";
1840 foreach my $option (@saved) {
1841 last if $option eq $ARGV[0];
1842 $ENV{MR_SWITCHES}.="$option ";
1848 print STDERR "mr: interrupted\n";
1852 # This can happen if it's run in a directory that was removed
1853 # or other strangeness.
1854 if (! defined $directory) {
1855 die("mr: failed to determine working directory\n");
1857 # Make sure MR_CONFIG is an absolute path, but don't use abs_path since
1858 # the config file might be a symlink to elsewhere, and the directory it's
1859 # in is significant.
1860 if ($ENV{MR_CONFIG} !~ /^\//) {
1861 $ENV{MR_CONFIG}=getcwd()."/".$ENV{MR_CONFIG};
1863 # Try to set MR_PATH to the path to the program.
1865 use FindBin qw($Bin $Script);
1866 $ENV{MR_PATH}=$Bin."/".$Script;
1882 help(@ARGV) if $ARGV[0] eq 'help';
1885 loadconfig($HOME_MR_CONFIG);
1886 loadconfig($ENV{MR_CONFIG});
1887 #use Data::Dumper; print Dumper(\%config);
1889 my $action=expandaction(shift @ARGV);
1896 # Finally, some useful actions that mr knows about by default.
1897 # These can be overridden in ~/.mrconfig.
1912 echo "mr (warning): $@" >&2
1918 if [ -z "$1" ] || [ -z "$2" ]; then
1919 error "mr: usage: hours_since action num"
1921 for dir in .git .svn .bzr CVS .hg _darcs _FOSSIL_; do
1922 if [ -e "$MR_REPO/$dir" ]; then
1923 flagfile="$MR_REPO/$dir/.mr_last$1"
1927 if [ -z "$flagfile" ]; then
1928 error "cannot determine flag filename"
1930 delta=`perl -wle 'print -f shift() ? int((-M _) * 24) : 9999' "$flagfile"`
1931 if [ "$delta" -lt "$2" ]; then
1939 LANG=C bzr info | egrep -q '^Checkout'
1942 if [ -d "$MR_REPO" ]; then
1949 svn_test = perl: -d "$ENV{MR_REPO}/.svn"
1950 git_test = perl: -e "$ENV{MR_REPO}/.git"
1951 bzr_test = perl: -d "$ENV{MR_REPO}/.bzr"
1952 cvs_test = perl: -d "$ENV{MR_REPO}/CVS"
1953 hg_test = perl: -d "$ENV{MR_REPO}/.hg"
1954 darcs_test = perl: -d "$ENV{MR_REPO}/_darcs"
1955 fossil_test = perl: -f "$ENV{MR_REPO}/_FOSSIL_"
1956 git_bare_test = perl:
1957 -d "$ENV{MR_REPO}/refs/heads" && -d "$ENV{MR_REPO}/refs/tags" &&
1958 -d "$ENV{MR_REPO}/objects" && -f "$ENV{MR_REPO}/config" &&
1959 `GIT_CONFIG="$ENV{MR_REPO}"/config git config --get core.bare` =~ /true/
1961 -d "$ENV{MR_REPO}/refs/heads" && -d "$ENV{MR_REPO}/refs/tags" &&
1962 -d "$ENV{MR_REPO}/objects" && -f "$ENV{MR_REPO}/config" &&
1963 `GIT_CONFIG="$ENV{MR_REPO}"/config git config --get vcsh.vcsh` =~ /true/
1964 veracity_test = perl: -d "$ENV{MR_REPO}/.sgdrawer"
1966 svn_update = svn update "$@"
1967 git_update = git pull "$@"
1969 if is_bzr_checkout; then
1972 bzr merge --pull "$@"
1974 cvs_update = cvs -q update "$@"
1975 hg_update = hg pull "$@"; hg update "$@"
1976 darcs_update = darcs pull -a "$@"
1977 fossil_update = fossil pull "$@"
1978 vcsh_update = vcsh run "$MR_REPO" git pull "$@"
1979 veracity_update = vv pull "$@" && vv update "$@"
1981 git_fetch = git fetch --all --prune --tags
1982 git_svn_fetch = git svn fetch
1983 darcs_fetch = darcs fetch
1986 svn_status = svn status "$@"
1987 git_status = git status -s "$@" || true; git --no-pager log --branches --not --remotes --simplify-by-decoration --decorate --oneline || true
1988 bzr_status = bzr status --short "$@"; bzr missing
1989 cvs_status = cvs -q status | grep -E '^(File:.*Status:|\?)' | grep -v 'Status: Up-to-date'
1990 hg_status = hg status "$@"; hg summary --quiet | grep -v 'parent: 0:'
1991 darcs_status = darcs whatsnew -ls "$@" || true
1992 fossil_status = fossil changes "$@"
1993 vcsh_status = vcsh run "$MR_REPO" git -c status.relativePaths=false status -s "$@" || true
1994 veracity_status = vv status "$@"
1996 svn_commit = svn commit "$@"
1997 git_commit = git commit -a "$@" && git push --all
1999 if is_bzr_checkout; then
2002 bzr commit "$@" && bzr push
2004 cvs_commit = cvs commit "$@"
2005 hg_commit = hg commit "$@" && hg push
2006 darcs_commit = darcs record -a "$@" && darcs push -a
2007 fossil_commit = fossil commit "$@"
2008 vcsh_commit = vcsh run "$MR_REPO" git commit -a "$@" && vcsh run "$MR_REPO" git push --all
2009 veracity_commit = vv commit "$@" && vv push
2011 git_record = git commit -a "$@"
2013 if is_bzr_checkout; then
2014 bzr commit --local "$@"
2018 hg_record = hg commit "$@"
2019 darcs_record = darcs record -a "$@"
2020 fossil_record = fossil commit "$@"
2021 vcsh_record = vcsh run "$MR_REPO" git commit -a "$@"
2022 veracity_record = vv commit "$@"
2025 git_push = git push "$@"
2026 bzr_push = bzr push "$@"
2028 hg_push = hg push "$@"
2029 darcs_push = darcs push -a "$@"
2030 fossil_push = fossil push "$@"
2031 vcsh_push = vcsh run "$MR_REPO" git push "$@"
2032 veracity_push = vv push "$@"
2034 svn_diff = svn diff "$@"
2035 git_diff = git diff "$@"
2036 bzr_diff = bzr diff "$@"
2037 cvs_diff = cvs -q diff "$@"
2038 hg_diff = hg diff "$@"
2039 darcs_diff = darcs diff -u "$@"
2040 fossil_diff = fossil diff "$@"
2041 vcsh_diff = vcsh run "$MR_REPO" git diff "$@"
2042 veracity_diff = vv diff "$@"
2044 svn_log = svn log "$@"
2045 git_log = git log "$@"
2046 bzr_log = bzr log "$@"
2047 cvs_log = cvs log "$@"
2048 hg_log = hg log "$@"
2049 darcs_log = darcs changes "$@"
2050 git_bare_log = git log "$@"
2051 fossil_log = fossil timeline "$@"
2052 vcsh_log = vcsh run "$MR_REPO" git log "$@"
2053 veracity_log = vv log "$@"
2055 hg_grep = hg grep "$@"
2056 cvs_grep = ack-grep "$@"
2057 svn_grep = ack-grep "$@"
2058 git_svn_grep = git grep "$@"
2059 git_grep = git grep "$@"
2060 bzr_grep = ack-grep "$@"
2065 url=`LC_ALL=C svn info . | grep -i '^URL:' | cut -d ' ' -f 2`
2066 if [ -z "$url" ]; then
2067 error "cannot determine svn url"
2069 echo "Registering svn url: $url in $MR_CONFIG"
2070 mr -c "$MR_CONFIG" config "`pwd`" checkout="svn co '$url' '$MR_REPO'"
2072 url="`LC_ALL=C git config --get remote.origin.url`" || true
2073 if [ -z "$url" ]; then
2074 error "cannot determine git url"
2076 echo "Registering git url: $url in $MR_CONFIG"
2077 mr -c "$MR_CONFIG" config "`pwd`" checkout="git clone '$url' '$MR_REPO'"
2079 url="`LC_ALL=C bzr info . | egrep -i 'checkout of branch|parent branch' | awk '{print $NF}' | head -n 1`"
2080 if [ -z "$url" ]; then
2081 error "cannot determine bzr url"
2083 echo "Registering bzr url: $url in $MR_CONFIG"
2084 mr -c "$MR_CONFIG" config "`pwd`" checkout="bzr branch '$url' '$MR_REPO'"
2086 repo=`cat CVS/Repository`
2088 if [ -z "$root" ]; then
2089 error "cannot determine cvs root"
2091 echo "Registering cvs repository $repo at root $root"
2092 mr -c "$MR_CONFIG" config "`pwd`" checkout="cvs -d '$root' co -d '$MR_REPO' '$repo'"
2094 url=`hg showconfig paths.default`
2095 echo "Registering mercurial repo url: $url in $MR_CONFIG"
2096 mr -c "$MR_CONFIG" config "`pwd`" checkout="hg clone '$url' '$MR_REPO'"
2098 url=`cat _darcs/prefs/defaultrepo`
2099 echo "Registering darcs repository $url in $MR_CONFIG"
2100 mr -c "$MR_CONFIG" config "`pwd`" checkout="darcs get '$url' '$MR_REPO'"
2102 url="`LC_ALL=C GIT_CONFIG=config git config --get remote.origin.url`" || true
2103 if [ -z "$url" ]; then
2104 error "cannot determine git url"
2106 echo "Registering git url: $url in $MR_CONFIG"
2107 mr -c "$MR_CONFIG" config "`pwd`" checkout="git clone --bare '$url' '$MR_REPO'"
2109 url="`LC_ALL=C vcsh run "$MR_REPO" git config --get remote.origin.url`" || true
2110 if [ -z "$url" ]; then
2111 error "cannot determine git url"
2113 echo "Registering git url: $url in $MR_CONFIG"
2114 mr -c "$MR_CONFIG" config "`pwd`" checkout="vcsh clone '$url' '$MR_REPO'"
2116 url=`fossil remote-url`
2117 repo=`fossil info | grep repository | sed -e 's/repository:*.//g' -e 's/ //g'`
2118 echo "Registering fossil repository $url in $MR_CONFIG"
2119 mr -c "$MR_CONFIG" config "`pwd`" checkout="mkdir -p '$MR_REPO' && cd '$MR_REPO' && fossil open '$repo'"
2121 url=`vv config | grep sync_targets | sed -e 's/sync_targets:*.//g' -e 's/ //g'`
2122 repo=`vv repo info | grep repository | sed -e 's/Current repository:*.//g' -e 's/ //g'`
2123 echo "Registering veracity repository $url in $MR_CONFIG"
2124 mr -c "$MR_CONFIG" config "`pwd`" checkout="mkdir -p '$MR_REPO' && cd '$MR_REPO' && vv checkout '$repo'"
2126 svn_trusted_checkout = svn co $url $repo
2127 svn_alt_trusted_checkout = svn checkout $url $repo
2128 git_trusted_checkout = git clone $url $repo
2129 bzr_trusted_checkout = bzr checkout|clone|branch|get $url $repo
2131 hg_trusted_checkout = hg clone $url $repo
2132 darcs_trusted_checkout = darcs get $url $repo
2133 git_bare_trusted_checkout = git clone --bare $url $repo
2134 vcsh_old_trusted_checkout = vcsh run "$MR_REPO" git clone $url $repo
2135 vcsh_trusted_checkout = vcsh clone $url $repo
2136 # fossil: messy to do
2137 veracity_trusted_checkout = vv clone $url $repo
2145 if [ -s ~/.mrlog ]; then
2146 info "running offline commands"
2147 mv -f ~/.mrlog ~/.mrlog.old
2148 if ! sh -e ~/.mrlog.old; then
2149 error "offline command failed; left in ~/.mrlog.old"
2153 info "no offline commands to run"
2158 info "offline mode enabled"
2160 info "remembering command: 'mr $@'"
2161 command="mr -d '$(pwd)' $MR_SWITCHES"
2163 command="$command '$w'"
2165 if [ ! -e ~/.mrlog ] || ! grep -q -F "$command" ~/.mrlog; then
2166 echo "$command" >> ~/.mrlog
2169 ed = echo "A horse is a horse, of course, of course.."
2170 T = echo "I pity the fool."
2171 right = echo "Not found."
2173 # vim:sw=8:sts=0:ts=8:noet
2175 # indent-tabs-mode: t
2176 # cperl-indent-level: 8